%define	major	2
%define	minor	2
%define	modules	%{mklibname %{name}}-modules
%define	libname %mklibname %{name} %{major}
%define	devname %mklibname %{name} -d
%define	static	%mklibname %{name} -s -d

%bcond_without	pcre
%bcond_without	png
%bcond_with	onig
%bcond_without	diet
%bcond_without	uclibc

Summary:	The shared library for the S-Lang extension language
Name:		slang
Version:	2.2.4
Release:	8
License:	GPLv2+
Group:		System/Libraries
URL:		http://www.s-lang.org
Source0:	ftp://ftp.fu-berlin.de/pub/unix/misc/slang/v%{major}.%{minor}/slang-%{version}.tar.bz2
Source1:	%{SOURCE0}.asc
Patch5:		slang-2.2.4-slsh-makefile.patch
Patch6:		slang-2.2.4-modules-makefile.patch
Patch7:		slang-2.2.4-perms.patch
Patch8:		slang-2.2.4-no-rpath.patch
BuildRequires:	pkgconfig(libpng)
BuildRequires:	libtool
BuildRequires:	pkgconfig(libpcre)
BuildRequires:	onig-devel
%if %{with diet}
BuildRequires:	dietlibc-devel
%endif
%if %{with uclibc}
BuildRequires:	uClibc-devel >= 0.9.33.2-15
%endif

%description
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.

%package -n	%{modules}
Summary:	Modules for the S-Lang extension language
Group:		Development/Other
Conflicts:	%{libname} < 2.2.4-3

%description -n	%{modules}
This package contains the main modules for the S-Lang extension language.

%package -n	%{libname}
Summary:	The shared library for the S-Lang extension language
Group:		System/Libraries
Requires:	%{modules} = %{EVRD}

%description -n	%{libname}
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.

%if %{with uclibc}
%package -n	uclibc-%{libname}
Summary:	The shared library for the S-Lang extension language linked against uClibc
Group:		System/Libraries

%description -n	uclibc-%{libname}
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.
%endif

%package -n	%{devname}
Summary:	The library and header files for development using S-Lang
Group:		Development/C
Provides:	%{name}-devel = %{EVRD}
Requires:	%{libname} = %{EVRD}
%if %{with uclibc}
Requires:	uclibc-%{libname} = %{version}
%endif

%description -n	%{devname}
This package contains the S-Lang extension language libraries and
header files which you'll need if you want to develop S-Lang based
applications.  Documentation which may help you write S-Lang based
applications is also included.

Install the slang-devel package if you want to develop applications
based on the S-Lang extension language.

%package -n	%{static}
Summary:	Static development files for %{name}
Group:		Development/C
Requires:	%{devname} = %{EVRD}
Provides:	%{name}-static-devel = %{EVRD}

%description -n	%{static}
Static development files for %{name}.

%package	source
Summary:	Source code %{name}
Group:		Development/C
Requires:	%{devname} = %{EVRD}

%description	source
This package contain source code for the slang library.

%description -n	%{static}
Static development files for %{name}.

%package	doc
Summary:	Extra documentation for slang libraries
Group:		Books/Computer books

%description	doc
This package contains documentation about S-Lang.
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.

%package	slsh
Summary:	S-Lang script interpreter
Group:		Shells

%description	slsh
slsh is a program that embeds the S-Lang interpreter and may be used
to test slang scripts.

%prep
%setup -q
%patch5 -p1
%patch6 -p1
%patch7 -p1 -b .lib_exec~
%patch8 -p1 -b .norpath~
%if %{with diet}
mkdir diet
cp -r autoconf configure doc demo mkfiles modules slang.lis slsh src utf8 changes.txt COPYING diet
%endif

%if %{with uclibc}
mkdir uclibc
cp -r autoconf configure doc demo mkfiles modules slang.lis slsh src utf8 changes.txt COPYING uclibc
%endif

%build
%if %{with diet}
pushd diet
./configure \
CC="diet gcc" CFLAGS="-Os -g"
make -C src/ static
popd
%endif

%if %{with uclibc}
pushd uclibc
%configure2_5x	--prefix=%{uclibc_root} \
		--libdir=%{uclibc_root}%{_libdir} \
		CC="%{uclibc_cc}" CFLAGS="%{uclibc_cflags}" LDFLAGS="%{ldflags} -Wl,-O2"
make -C src/ static $PWD/src/elfobjs/libslang.so.%{version}
popd
%endif

%configure2_5x	--with-{onig,pcre,png,z}lib=%{_libdir} \
		--with-{onig,pcre,png,z}inc=%{_includedir} \
		--includedir=%{_includedir}/slang

make

%check
make check

%install
%makeinstall_std install-static

%if %{with diet}
install -m644 diet/src/objs/libslang.a -D %{buildroot}%{_prefix}/lib/dietlibc/lib-%{_arch}/libslang.a
%endif

install -d %{buildroot}%{_prefix}/src/slang
cp src/Makefile src/*.{c,h,inc} %{buildroot}%{_prefix}/src/slang

%if !%{with uclibc}
cp src/config.h %{buildroot}%{_prefix}/src/slang
%else
cp uclibc/src/config.h %{buildroot}%{_prefix}/src/slang
install -m644 uclibc/src/objs/libslang.a -D %{buildroot}%{uclibc_root}%{_libdir}/libslang.a
cp -a uclibc/src/elfobjs/libslang.so* %{buildroot}%{uclibc_root}%{_libdir}
%endif

%files -n %{modules}
%dir %{_libdir}/slang
%{_libdir}/slang/v%{major}

%files -n %{libname}
%{_libdir}/libslang.so.%{major}*

%if %{with uclibc}
%files -n uclibc-%{libname}
%{uclibc_root}%{_libdir}/libslang.so.%{major}*
%endif

%files -n %{devname}
%{_libdir}/libslang.so
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libslang.so
%endif
%dir %{_includedir}/slang/
%{_includedir}/slang/*.h
%{_libdir}/pkgconfig/slang.pc

%files -n %{static}
%{_libdir}/libslang.a
%if %{with diet}
%{_prefix}/lib/dietlibc/lib-%{_arch}/libslang.a
%endif
%if %{with uclibc}
%{_prefix}/uclibc%{_libdir}/libslang.a
%endif

%files source
%dir %{_prefix}/src/slang
%{_prefix}/src/slang/Makefile
%{_prefix}/src/slang/*.c
%{_prefix}/src/slang/*.h
%{_prefix}/src/slang/*.inc

%files doc
%{_defaultdocdir}/slang

%files slsh
%doc %{_docdir}/slsh
%{_bindir}/slsh
%{_datadir}/slsh
%{_mandir}/man1/slsh.1*
%config(noreplace) %{_sysconfdir}/slsh.rc


%changelog
* Sun Oct 28 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.2.4-8
+ Revision: 820096
- add dependency on uclibc library package for devel package
- create a slang-source package with the source made available for others
  packages to compile it in with -fwhole-program
- build against latest uClibc for locale support

* Wed Jun 06 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.2.4-6
+ Revision: 802829
- drop unused %%{_bindir}/slsh provides
- fix linking against uclibc

* Wed Jun 06 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.2.4-5
+ Revision: 802824
- build uclibc dynamically linked version of library

* Thu May 24 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.2.4-4
+ Revision: 800342
- add conditional buildrequires on dietlibc-devel & uClibc-devel
- build static library version against uclibc & diet

* Wed Mar 07 2012 Per Øyvind Karlsen <peroyvind@mandriva.org> 2.2.4-3
+ Revision: 782937
- parallel build seems flakey, disable it for now..
- fix conffile-without-noreplace-flag
- split out modules into separate package
- use pkgconfig() deps for buildrequires
- fix build of libpng, libpcre, libonig & libz module & enable unconditionally
- get rid of rpath (P8)
- install libraries with executable permissions (P7, from Fedora)
- use %%{EVRD} macro
- drop ancient obsoletes
- drop excessive provides
- remove buildconflicts on slang-devel
- cleanups

* Tue Feb 07 2012 Dmitry Mikhirev <dmikhirev@mandriva.org> 2.2.4-2
+ Revision: 771692
- rebuild for new pcre

* Tue Sep 13 2011 Tomasz Pawel Gajc <tpg@mandriva.org> 2.2.4-1
+ Revision: 699605
- update to new version 2.2.4
- drop old pacthes
- Patch 5 and 6 : link against source slang library
- disable parallel build

  + Lonyai Gergely <aleph@mandriva.org>
    - rebuild

* Fri May 06 2011 Oden Eriksson <oeriksson@mandriva.com> 2.2.2-3
+ Revision: 669985
- mass rebuild

  + Funda Wang <fwang@mandriva.org>
    - tighten BR

* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 2.2.2-2mdv2011.0
+ Revision: 607541
- rebuild

* Thu Dec 31 2009 Tomasz Pawel Gajc <tpg@mandriva.org> 2.2.2-1mdv2010.1
+ Revision: 484500
- update to new version 2.2.2
- drop patch 3, fixed upstream
- rediff patch 2

* Wed Sep 09 2009 Frederik Himpe <fhimpe@mandriva.org> 2.2.1-1mdv2010.0
+ Revision: 436042
- Update to new version 2.2.1

* Tue Aug 04 2009 Frederik Himpe <fhimpe@mandriva.org> 2.2.0-1mdv2010.0
+ Revision: 409523
- Update to new version 2.2.0

* Tue Dec 09 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 2.1.4-1mdv2009.1
+ Revision: 312369
- add switches abd buildrequires for oniguruma library, not enabled by default
- do not obsolete yourself
- spec file clean
- update to new version 2.1.4

* Wed Jul 02 2008 Oden Eriksson <oeriksson@mandriva.com> 2.1.3-3mdv2009.0
+ Revision: 230754
- added P4 to fix linkage
- rebuild

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild
    - fix no-buildroot-tag

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Tue Jan 08 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 2.1.3-1mdv2008.1
+ Revision: 146921
- drop patch 1
- add two Fedora's patches
- add missing buildrequires on X11-devel
- new version 2.1.3
- use macros
- fix file list

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request
    - fix summary-ended-with-dot

  + Adam Williamson <awilliamson@mandriva.org>
    - use Fedora license policy (GPLv2+)
    - new devel policy
    - spec clean
    - new release 2.1.1

* Tue May 29 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.1.0-1mdv2008.0
+ Revision: 32583
- Updated to version 2.1.0.
- Removed utf8 patches, support upstream.
- Removed uneeded/obsolete patch gcc4.
- Updated URL field.
- Redid no-glibc-private patch.
- Added slsh_install patch, to fix build (make install) when slang 1
  is installed on the system with its devel files.
- Added conditionals for building of pcre/png modules.
- libslang2-devel: soname change, conflict with old libslang1-devel.
- Added static-devel subpackage, following policy.
- This new slang provides slsh (S-Lang interpreter), provide it in a new
  subpackage (slang-slsh).


* Fri Nov 03 2006 Anssi Hannula <anssi@mandriva.org> 1.4.9-10mdv2007.0
+ Revision: 76225
- patch15: do not use glibc private symbol

* Thu Nov 02 2006 Oden Eriksson <oeriksson@mandriva.com> 1.4.9-9mdv2007.1
+ Revision: 75576
- bunzip patches
- fix deps
- spec file massage
- Import slang

* Sun Jan 01 2006 Mandriva Linux Team <http://www.mandrivaexpert.com/> 1.4.9-8mdk
- Rebuild

* Thu Aug 25 2005 Warly <warly@mandriva.com> 1.4.9-7mdk
- add a patch to fix a segv and to build with gcc4

* Sun Aug 29 2004 Marcel Pol <mpol@mandrake.org> 1.4.9-6mdk
- patch5, fix off by one error

* Fri Jul 23 2004 Marcel Pol <mpol@mandrake.org> 1.4.9-5mdk
- revert soname change

* Thu Jul 22 2004 Marcel Pol <mpol@mandrake.org> 1.4.9-4mdk
- utf8 patches from suse, new soname
- make compat symlinks for devel package

